"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

require("core-js/modules/es.function.name");

exports.__esModule = true;
exports.createControlledLayer = createControlledLayer;
exports.LayersControl = exports.useLayersControl = exports.useLayersControlElement = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose"));

var _core = require("@react-leaflet/core");

var _leaflet = require("leaflet");

var _react = _interopRequireWildcard(require("react"));

var useLayersControlElement = (0, _core.createElementHook)(function createLayersControl(_ref, ctx) {
  var _c = _ref.children,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["children"]);
  var instance = new _leaflet.Control.Layers(undefined, undefined, options);
  return {
    instance: instance,
    context: (0, _assign.default)({}, ctx, {
      layersControl: instance
    })
  };
}, function updateLayersControl(control, props, prevProps) {
  if (props.collapsed !== prevProps.collapsed) {
    if (props.collapsed === true) {
      control.collapse();
    } else {
      control.expand();
    }
  }
});
exports.useLayersControlElement = useLayersControlElement;
var useLayersControl = (0, _core.createControlHook)(useLayersControlElement);
exports.useLayersControl = useLayersControl;
// @ts-ignore
var LayersControl = (0, _core.createContainerComponent)(useLayersControl);
exports.LayersControl = LayersControl;

function createControlledLayer(addLayerToControl) {
  return function ControlledLayer(props) {
    var parentContext = (0, _core.useLeafletContext)();
    var propsRef = (0, _react.useRef)(props);

    var _useState = (0, _react.useState)(null),
        layer = _useState[0],
        setLayer = _useState[1];

    var layersControl = parentContext.layersControl,
        map = (0, _map.default)(parentContext);
    var addLayer = (0, _react.useCallback)(function (layerToAdd) {
      if (layersControl != null) {
        if (propsRef.current.checked) {
          map.addLayer(layerToAdd);
        }

        addLayerToControl(layersControl, layerToAdd, propsRef.current.name);
        setLayer(layerToAdd);
      }
    }, [layersControl, map]);
    var removeLayer = (0, _react.useCallback)(function (layerToRemove) {
      layersControl == null ? void 0 : layersControl.removeLayer(layerToRemove);
      setLayer(null);
    }, [layersControl]);
    var context = (0, _react.useMemo)(function () {
      return (0, _assign.default)({}, parentContext, {
        layerContainer: {
          addLayer: addLayer,
          removeLayer: removeLayer
        }
      });
    }, [parentContext, addLayer, removeLayer]);
    (0, _react.useEffect)(function () {
      if (layer !== null && propsRef.current !== props) {
        if (props.checked === true && (propsRef.current.checked == null || propsRef.current.checked === false)) {
          map.addLayer(layer);
        } else if (propsRef.current.checked === true && (props.checked == null || props.checked === false)) {
          map.removeLayer(layer);
        }

        propsRef.current = props;
      }
    });
    return props.children ? /*#__PURE__*/_react.default.createElement(_core.LeafletProvider, {
      value: context
    }, props.children) : null;
  };
}

LayersControl.BaseLayer = createControlledLayer(function addBaseLayer(layersControl, layer, name) {
  layersControl.addBaseLayer(layer, name);
});
LayersControl.Overlay = createControlledLayer(function addOverlay(layersControl, layer, name) {
  layersControl.addOverlay(layer, name);
});