import "core-js/modules/es.function.name";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/esm/objectWithoutPropertiesLoose";
import { LeafletProvider, createContainerComponent, createControlHook, createElementHook, useLeafletContext } from '@react-leaflet/core';
import { Control } from 'leaflet';
import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react';
export var useLayersControlElement = createElementHook(function createLayersControl(_ref, ctx) {
  var _c = _ref.children,
      options = _objectWithoutPropertiesLoose(_ref, ["children"]);

  var instance = new Control.Layers(undefined, undefined, options);
  return {
    instance: instance,
    context: _Object$assign({}, ctx, {
      layersControl: instance
    })
  };
}, function updateLayersControl(control, props, prevProps) {
  if (props.collapsed !== prevProps.collapsed) {
    if (props.collapsed === true) {
      control.collapse();
    } else {
      control.expand();
    }
  }
});
export var useLayersControl = createControlHook(useLayersControlElement);
// @ts-ignore
export var LayersControl = createContainerComponent(useLayersControl);
export function createControlledLayer(addLayerToControl) {
  return function ControlledLayer(props) {
    var parentContext = useLeafletContext();
    var propsRef = useRef(props);

    var _useState = useState(null),
        layer = _useState[0],
        setLayer = _useState[1];

    var layersControl = parentContext.layersControl,
        map = _mapInstanceProperty(parentContext);

    var addLayer = useCallback(function (layerToAdd) {
      if (layersControl != null) {
        if (propsRef.current.checked) {
          map.addLayer(layerToAdd);
        }

        addLayerToControl(layersControl, layerToAdd, propsRef.current.name);
        setLayer(layerToAdd);
      }
    }, [layersControl, map]);
    var removeLayer = useCallback(function (layerToRemove) {
      layersControl == null ? void 0 : layersControl.removeLayer(layerToRemove);
      setLayer(null);
    }, [layersControl]);
    var context = useMemo(function () {
      return _Object$assign({}, parentContext, {
        layerContainer: {
          addLayer: addLayer,
          removeLayer: removeLayer
        }
      });
    }, [parentContext, addLayer, removeLayer]);
    useEffect(function () {
      if (layer !== null && propsRef.current !== props) {
        if (props.checked === true && (propsRef.current.checked == null || propsRef.current.checked === false)) {
          map.addLayer(layer);
        } else if (propsRef.current.checked === true && (props.checked == null || props.checked === false)) {
          map.removeLayer(layer);
        }

        propsRef.current = props;
      }
    });
    return props.children ? /*#__PURE__*/React.createElement(LeafletProvider, {
      value: context
    }, props.children) : null;
  };
}
LayersControl.BaseLayer = createControlledLayer(function addBaseLayer(layersControl, layer, name) {
  layersControl.addBaseLayer(layer, name);
});
LayersControl.Overlay = createControlledLayer(function addOverlay(layersControl, layer, name) {
  layersControl.addOverlay(layer, name);
});